<!DOCTYPE html>
<html>
  <head>
    <link rel="stylesheet" type="text/css" href="https://pyscript.net/alpha/pyscript.css"/>
    <link rel="stylesheet" type="text/css" href="static/style.css"/>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>DRB Python Training</title>
    <script defer src="https://pyscript.net/alpha/pyscript.js"></script>
    <script src="static/check.js"></script>

    <title>
        <b>DRB Python Training</b>
    </title>
</head>


  <body class="my_body">
    <h1 class="big_title">Topics & Addons</h1>

<br/>
<br/>
<p>
    A topic represents a node hierarchy defining a format, a topic may also derive from another topic:
</p>

<img class="resize" src="static/images/topic.png">


<h2 class="chapter">Topic Structure:</h3>
<br/>
<table>
    <thead>
      <tr>
        <th style="width:100px">Field</th>
        <th>Required</th>
        <th style="width:150px">Type</th>
        <th>Description</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td>id</td>
        <td>Yes</td>
        <td>String</td>
        <td>
            A hexadecimal UUID representation following RCF 4122.
        </td>
      </tr>
      <tr>
        <td>subClassOf</td>
        <td>No</td>
        <td>String</td>
        <td>
            A hexadecimal UUID representation following RCF 4122.
        </td>
      </tr>
      <tr>
        <td>label</td>
        <td>Yes</td>
        <td>String</td>
        <td>
            Item class label.
        </td>
      </tr>
      <tr>
        <td>description</td>
        <td>No</td>
        <td>String</td>
        <td>
            Item class description
        </td>
      </tr>
      <tr>
        <td>category</td>
        <td>Yes</td>
        <td>String</td>
        <td>
            Item class category (PROTOCOL, CONTAINER or FORMATTING)
        </td>
      </tr>
      <tr>
        <td>factory</td>
        <td>No</td>
        <td>String</td>
        <td>
            Allowing to define a specific view for a node of this item class
        </td>
      </tr>
      <tr>
        <td>signatures</td>
        <td>No</td>
        <td>Array[Signature]</td>
        <td>
            Describe recognition node mechanism
        </td>
      </tr>
    </tbody>
  </table>
  <br/>
  <p>
    Example:
  </p>
  <pre>
    <code class="language-yml"> 
id: c11f70f2-6847-48dd-b31c-150500f3f2b6         # topic identifier
subClassOf: 487b0c70-6199-46de-9e41-4914520e25d9 # identifier of topic "parent"
label: Sentinel-1 Product                        # topic label
description:                                     # topic description
category: CONTAINER                              # topic category
signatures:                                      # topic signatures
    - name: S1[AB]_.{63}.SAFE
      </code>
  </pre>
  <br/>

  <h2 class="chapter">Signature</h2>
  <br/>

  <p>
    A signature define a recognation node mechanism. Several kind of signature exist:
  </p>
    <ul>
        <li>Name signature</li>
        <li>Namespace  signature</li>
        <li>Path signature</li>
        <li>Attributes signature</li>
        <li>Children signature</li>
        <li>XQuery signature</li>
        <li>python</li>
    </ul>
    <p>
    For more details about signature, please see <a href="https://drb-python.gitlab.io/drb/dev/plugin.html#signatures">https://drb-python.gitlab.io/drb/dev/plugin.html#signatures</a>
  </p>
  <br/>
  <h2 class="sub_chapter">Signature logical operations</h2>

  <p>
    OR and AND operations can be done on signatures:
    <br/>
    <br/>
    Logical OR
  </p>
    <pre>
        <code class="language-yml"> 
signatures:
- name: (?i).+\\.xml
- attributes:
    name: 'Content-Type'
    value: 'application/xml'
          </code>
      </pre>
    <p>Logical AND</p>
    <pre>
        <code class="language-yml"> 
signatures:
- name: (?i).+\\.safe
    children:
    name: (?i)(manifest\\.(safe|xml|xfdu)|xfdumanifest\\.xml)
          </code>
      </pre>
  <br/>

  <h2 class="chapter">How to retrieve a node topic</h2>
  <br/>
  
  <table>
    <thead>
      <tr>
        <th>Topic</th>
        <th>URL</th>
        <th style="width:100px">Status</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td>drb-topic-safe</td>
        <td><a href="https://gitlab.com/drb-python/topics/safe">https://gitlab.com/drb-python/topics/safe</a></td>
        <td>done</td>
      </tr>
      <tr>
        <td>drb-topic-sentinel1</td>
        <td><a href="https://gitlab.com/drb-python/topics/sentinel-1">https://gitlab.com/drb-python/topics/sentinel-1</a></td>
        <td>done</td>
      </tr>
      <tr>
        <td>drb-topic-sentinel2</td>
        <td><a href="https://gitlab.com/drb-python/topics/sentinel2">https://gitlab.com/drb-python/topics/sentinel2</a></td>
        <td>done</td>
      </tr>
      <tr>
        <td>drb-topic-sentinel3</td>
        <td><a href="https://gitlab.com/drb-python/topics/sentinel3">https://gitlab.com/drb-python/topics/sentinel3</a></td>
        <td>done</td>
      </tr>
      <tr>
        <td>drb-topic-sentinel5</td>
        <td><a href="https://gitlab.com/drb-python/topics/sentinel5p">https://gitlab.com/drb-python/topics/sentinel5p</a></td>
        <td>done</td>
      </tr>
    </tbody>
  </table>
  <br/>
  <p>
    The resolver can also provide topic for a node via the resolve method:
  </p>
  <pre>
    <code class="language-py"> 
from drb.factory import DrbFactoryResolver

resolver = DrbFactoryResolver()
topic, node = resolver.resolve("S1A_EW_GRDM_1SDH_20191023T181241_20191023T181348_029589_035E6D_0238.SAFE")
      </code>
  </pre>
  <br/>

<h2 class="chapter">Addons</h2>
<br/>
<p>An add-on allowing to attach one or more propeties to a topic, in order to be used by an application.</p>
<br/>
<h2 class="chapter">DRB Metadata</h2>
<p>DRB Metadata is a DRB applicative part using addons to extract easily metadata from a DRB node.</p>
<pre>
    <code class="language-py"> 
from drb.factory import DrbFactoryResolver
from drb_metadata import DrbMetadataResolver

# generate node
resource_path = '/path/to/my/resource'
node = DrbFactoryResolver().create(resource_path)

# retrieve metadata associated to the given topic --> returns a Dict[str, Metadata]
metadata = DrbMetadataResolver().get_metadata(node)

# display specific metadata: platformName is present
name = 'plaformShortName'
if name in metadata:
    print(f'{name}: {metadata[name].extract(node)}')

# display all metadata
for name, extractor in metadata.items():
    print(name, ' -- ', extractor.extract(node))
      </code>
  </pre>
<h2 class="chapter">How to define metadata ?</h2>

<p>A metadata is defined in a YAML file cortex.yml:</p>

<pre>
    <code class="language-yml"> 
drbItemClass: aff2191f-5b06-4121-a9fa-f3d93f6c6331
variables:
    - name: node_platform
    xquery: |
        ./manifest.safe/XFDU/metadataSection/metadataObject[@ID="platform"]/
        metadataWrap/xmlData/platform
metadata:
    - name: 'platformName'
    constant: 'Sentinel-1'

- name: 'SatelliteNumber'
    xquery: |
        declare variable $node_platform external;
        data($node_platform/number)

- name: 'platformIdentifier'
    python: |
        return node_platform['nssdcIdentifier'].value

- name: 'resolutionDetail'
    python: |
        resolution = node.name[10:11]
        if resolution == 'F':
        return 'Full'
        elif resolution == 'H':
        return 'High'
        elif resolution == 'M':
        return 'Medium'
        return None
      </code>
  </pre>
  <br/>
  <br/>
    <footer>
      <p><a href="xquery.html">Xquery</a></p>
      <p><a href="/">Home Page</a></p>
    </footer>
    <footer id="err-div" class="bg-red-700 text-white text-center border-t-4 border-green-500 fixed inset-x-0 bottom-0 p-4 hidden"/>

  </body>
</html>
